import { GetOptions } from "infisical-node/src/types/InfisicalClient";
import { InfisicalClient } from "..";

let MONGO_URI: string;

/**
 * Initialize the secrets
 */
export async function initSecrets() {
  const options: GetOptions = {
    environment: process.env.NODE_ENV === "production" ? "main" : "dev",
    path: "/",
    type: "shared",
  };

  const mongoUri = (await InfisicalClient.getSecret("MONGO_URI", options))
    .secretValue;

  if (!mongoUri) {
    console.log("MONGO_URI not set in secrets");
    process.exit(1);
  }

  MONGO_URI = mongoUri;
}

/**
 * All of the Infisical secrets
 */
export const Secrets = {
  get MONGO_URI() {
    return MONGO_URI;
  },
};
